import 'package:flutter/material.dart';

import 'package:yuro_core/yuro_core.dart';
import 'package:yuro_route/yuro_route.dart';
import 'package:yuro_translation/yuro_translation.dart';

import 'yuro_app_controller.dart';

extension YuroStateExt on YuroInterface {
  static final YuroAppController _appController = YuroAppController();

  YuroAppController get appController => _appController;

  void forceRestart() => _appController.forceRestart();

  void changeLocale(Locale locale) {
    if (Yuro.locale != locale) {
      Yuro.locale = locale;
      _appController.forceRestart();
    }
  }

  void changeThemeMode(ThemeMode themeMode) => _appController.changeThemeMode(themeMode);

  void changeTheme(ThemeData theme) => _appController.changeTheme(theme);

  ThemeData get theme => Theme.of(Yuro.navigatorKey.currentContext);

  TextTheme get textTheme => theme.textTheme;

  ThemeMode get themeMode => _appController.themeMode;
}
